package com.sa.ibiz.demo.demoapp.controller.demo;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.sql.Timestamp;
import javax.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.sa.ibiz.demo.ibizutil.domain.ActionResult;
import com.sa.ibiz.demo.demo.service.OrgUserService;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import com.sa.ibiz.demo.demo.domain.OrgUser;
import com.sa.ibiz.demo.demo.service.dto.OrgUserSearchFilter;
import com.sa.ibiz.demo.demoapp.controller.demo.vo.*;
import org.springframework.cglib.beans.BeanGenerator;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.util.StringUtils;
import java.io.IOException;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.validation.annotation.Validated;
import org.springframework.http.ResponseEntity;
import org.springframework.beans.factory.annotation.Autowired;
import com.sa.ibiz.demo.ibizutil.domain.RedirectResult;
import javax.validation.constraints.NotBlank;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@RestController
@RequestMapping("/demoapp/demo/orguser")
public class OrgUserController{



    @Autowired
	private OrgUserService orguserService;
	/**
	 * 获取服务对象
	*/
	protected OrgUserService getService(){
		return this.orguserService;
	}



	@PostMapping(value="main2editform/update")
	public ResponseEntity<OrgUser_EditForm_Main2> main2EditFormUpdate(@Validated @RequestBody OrgUser_EditForm_Main2 form){
            OrgUser entity =form.toOrgUser();
            getService().update(entity);
            form.fromOrgUser(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="main2editform/remove")
	public ResponseEntity<OrgUser_EditForm_Main2> main2EditFormRemove(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            OrgUser_EditForm_Main2 form=new OrgUser_EditForm_Main2();
            OrgUser entity = new OrgUser();
            entity.setOrguserid(srfkey);
            getService().remove(entity);
            form.setSrfuf("0");
            form.fromOrgUser(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="main2editform/getdraft")
	public ResponseEntity<OrgUser_EditForm_Main2> main2EditFormGetDraft(@RequestBody OrgUser_EditForm_Main2 form){
        if(!StringUtils.isEmpty(form.getSrfsourcekey()))
        {
            OrgUser sourceEntity =new OrgUser();
            sourceEntity.setOrguserid(form.getSrfsourcekey());
            this.getService().get(sourceEntity);

			OrgUser targetEntity =new OrgUser();
			sourceEntity.copyTo(targetEntity);
			form.fromOrgUser(targetEntity,false);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
         }
            OrgUser entity =form.toOrgUser();
            getService().getDraft(entity);
            form.fromOrgUser(entity);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="main2editform/get")
	public ResponseEntity<OrgUser_EditForm_Main2> main2EditFormGet(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            OrgUser_EditForm_Main2 form=new OrgUser_EditForm_Main2();
            OrgUser entity = new OrgUser();
            entity.setOrguserid(srfkey);
            entity=getService().get(entity);
            form.setSrfuf("1");
            form.fromOrgUser(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="main2editform/create")
	public ResponseEntity<OrgUser_EditForm_Main2> main2EditFormCreate(@Validated @RequestBody OrgUser_EditForm_Main2 form){
            OrgUser entity =form.toOrgUser();
            getService().create(entity);
            form.fromOrgUser(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.OrgService orgService;
	@PostMapping(value="main2editform/orgname/ac")
	public ResponseEntity<List<AutoCompleteItem>> main2EditForm_orgname_ac(@RequestBody OrgUser_EditForm_Main2 form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.OrgSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.OrgSearchFilter();
		OrgUser entity =form.toOrgUser();
		String queryField=entity.getOrgname();
		searchFilter.getSelectCond().like("orgname",queryField);
		Page<com.sa.ibiz.demo.demo.domain.Org> searchResult = orgService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.Org entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getOrgid());
			acItem.setText(entity2.getOrgname());
			acItem.setRealtext(entity2.getOrgname());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.OrgSectorService orgsectorService;
	@PostMapping(value="main2editform/orgsectorname/ac")
	public ResponseEntity<List<AutoCompleteItem>> main2EditForm_orgsectorname_ac(@RequestBody OrgUser_EditForm_Main2 form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.OrgSectorSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.OrgSectorSearchFilter();
		OrgUser entity =form.toOrgUser();
		String queryField=entity.getOrgsectorname();
		searchFilter.getSelectCond().like("orgsectorname",queryField);
		//OrgSectorSearchFilter.ActiveData activeData = new OrgSectorSearchFilter.ActiveData();
		//OrgUser orgUser = toOrgUser(main2);
		//	
		//Object value0 = this.getService().getActiveDataField(orgUser,"orgid","ORGSECTOR","ORGID","main2editform_orgsectorname");
		//if(value0!=null){
		//	BeanUtils.setProperty(activeData,"orgid",value0);
		//}
		//	
		//searchFilter.setActivedata(activeData);
		Page<com.sa.ibiz.demo.demo.domain.OrgSector> searchResult = orgsectorService.searchCurOrg(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.OrgSector entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getOrgsectorid());
			acItem.setText(entity2.getOrgsectorname());
			acItem.setRealtext(entity2.getOrgsectorname());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.OrgSecUserTypeService orgsecusertypeService;
	@PostMapping(value="main2editform/orgsecusertypename/ac")
	public ResponseEntity<List<AutoCompleteItem>> main2EditForm_orgsecusertypename_ac(@RequestBody OrgUser_EditForm_Main2 form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.OrgSecUserTypeSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.OrgSecUserTypeSearchFilter();
		OrgUser entity =form.toOrgUser();
		String queryField=entity.getOrgsecusertypename();
		searchFilter.getSelectCond().like("orgsecusertypename",queryField);
		Page<com.sa.ibiz.demo.demo.domain.OrgSecUserType> searchResult = orgsecusertypeService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.OrgSecUserType entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getOrgsecusertypeid());
			acItem.setText(entity2.getOrgsecusertypename());
			acItem.setRealtext(entity2.getOrgsecusertypename());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.OrgUserLevelService orguserlevelService;
	@PostMapping(value="main2editform/orguserlevelname/ac")
	public ResponseEntity<List<AutoCompleteItem>> main2EditForm_orguserlevelname_ac(@RequestBody OrgUser_EditForm_Main2 form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.OrgUserLevelSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.OrgUserLevelSearchFilter();
		OrgUser entity =form.toOrgUser();
		String queryField=entity.getOrguserlevelname();
		searchFilter.getSelectCond().like("orguserlevelname",queryField);
		Page<com.sa.ibiz.demo.demo.domain.OrgUserLevel> searchResult = orguserlevelService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.OrgUserLevel entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getOrguserlevelid());
			acItem.setText(entity2.getOrguserlevelname());
			acItem.setRealtext(entity2.getOrguserlevelname());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@PostMapping(value="main2grid/update")
	public OrgUser main2GridUpdate(@Validated OrgUser main2Item){
		return main2Item;
	}
	@PostMapping(value="main2grid/remove")
	public ResponseEntity<OrgUser> main2GridRemove(@Validated @RequestBody Map args){
	    OrgUser entity =new OrgUser();
	    if ( !StringUtils.isEmpty(args.get("srfkeys"))) {
			String srfkeys=args.get("srfkeys").toString();
			String srfkeyArr[] =srfkeys.split(";");
			for(String srfkey : srfkeyArr)
			{
				if(!StringUtils.isEmpty(srfkey)){
				entity.setOrguserid(srfkey);
				this.getService().remove(entity);
                }
            }
        }
		return ResponseEntity.ok().body(entity);
	}
	public OrgUser main2GridGet(String orguserid){
		return null;
	}
	@PostMapping(value="main2grid/getdraft")
	public OrgUser main2GridGetDraft(@Validated OrgUser main2Item){
		return main2Item;
	}
	@PostMapping(value="main2grid/create")
	public OrgUser main2GridCreate(@Validated OrgUser main2Item){
		return main2Item;
	}
	@org.springframework.beans.factory.annotation.Value("${ibiz.filePath}")
    private String strFilePath;
	@Autowired
    private com.sa.ibiz.demo.ibizutil.service.IBZFILEService ibzfileService;
	/**
	 * [main2]表格数据导出
	 * @param searchFilter
	 * @return
	 * @throws
	 * @throws
	 */
	@PostMapping(value="main2grid/exportdata/searchdefault")
	public ResponseEntity<Page<JSONObject>> main2gridExportDataSearchDefault(@Validated @RequestBody OrgUserSearchFilter searchFilter) throws IOException, jxl.write.WriteException {
		String fileid=com.baomidou.mybatisplus.core.toolkit.IdWorker.get32UUID();
		String localPath=ExportDataInit(fileid);//输出文件相对路径
		Page<OrgUser> searchResult = this.getService().searchDefault(searchFilter);//1.查询表格数据
		List<Map<String,Object>> datas=OrgUser_Grid_Main2.pageToListDatas(searchResult);//2.将数据转换成list
		List<Map<String,String>> colnums=OrgUser_Grid_Main2.getGridColumnModels();//3.获取表格列头
        java.io.File outputFile=com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.output(strFilePath+localPath,colnums,datas);//4.生成导出文件
		com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.saveFileData(outputFile,localPath,fileid,ibzfileService); //5.保存file表记录
		String strDownloadUrl =String.format("ibizutil/download/"+fileid);//6.回传文件路径给前台
        Page<JSONObject> resultObj=OrgUser_Grid_Main2.getResultPage(searchResult,strDownloadUrl);//7.获取输出对象
			return ResponseEntity.ok().body(resultObj);
	}
	/**
	 * 表格数据导出
	 * @param fileid
	 * @return
	 */
	private String ExportDataInit(String fileid) {
		java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("yyyyMMdd");
        String filepath=dateFormat.format(new java.util.Date())+ java.io.File.separator;
        java.text.SimpleDateFormat dateFormat2 = new java.text.SimpleDateFormat("yyyyMMddHHmmss");
		String strTempFileName = fileid+"-"+dateFormat2.format(new java.util.Date())+".xls";
		java.io.File file =new java.io.File(strFilePath+filepath);
		if(!file.exists())
           file.mkdirs();
		return filepath+strTempFileName;
	}
	@PostMapping(value="main2grid/searchdefault")
	public ResponseEntity<Page<OrgUser_Grid_Main2>> main2GridSearchDefault(@Validated @RequestBody OrgUserSearchFilter searchFilter){
			Page<OrgUser> searchResult = this.getService().searchDefault(searchFilter);
			Page<OrgUser_Grid_Main2> searchResult_vo_data =OrgUser_Grid_Main2.fromOrgUser(searchResult);
					return ResponseEntity.ok().body(searchResult_vo_data);
	}
	@PostMapping(value="defaultsearchform/load")
	public void defaultSearchFormLoad(){

	}
   	@PostMapping(value="defaultsearchform/loaddraft")
	public ResponseEntity<OrgUser_SearchForm_Default> defaultSearchFormLoadDraft(@Validated @RequestBody OrgUser_SearchForm_Default searchform){
 		 
			OrgUserSearchFilter searchfilter =searchform.toOrgUserSearchFilter();
			searchform.fromOrgUserSearchFilter(searchfilter);
			return ResponseEntity.ok().body(searchform);
	} 
	@PostMapping(value="defaultsearchform/search")
	public void defaultSearchFormSearch(){
			 
	} 
 }